<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { useI18n } from 'vue-i18n';
import { storeToRefs } from 'pinia';
import { computed, inject } from 'vue';
import MailChooser from '@/components/general/form/MailChooser.vue';
import Input from '@/components/general/form/Input.vue';
import { useCreateStore } from '@/stores/create';
import Button from '../general/Button.vue';
import PasswordField from '../general/form/PasswordField.vue';
import { validMail } from '@/lib/utils';

const createStore:any = useCreateStore();
const { t } = useI18n();

const { hashcode, mail, aPassword, uPassword, type, aPasswordValid, uPasswordValid, headline, subheadline, activePage, isCreate, accesscode, lineText, lineSize, lineColor } = storeToRefs(createStore);

const selectUI = (ui: string) => {
    type.value = ui;
    if (ui === "Timeline") {
        lineText.value = false;
        lineSize.value = 2;
        lineColor.value = "#666666";
    }
    else if (ui === "Freeform") {
        lineText.value = true;
        lineSize.value = 1;
        lineColor.value = "black";
    }
};

const checkMail = computed(() => {
    return validMail(mail.value);
});

const setDomain = (domain: string) => {
    domain = domain;
};
const setUsername = (username: string) => {
    username = username;
}
const $t = t;

const setActivePage = () => {
    activePage.value = "important";
}
</script>

<template>
    <div class="h-full flex flex-col justify-between">
        <input hidden name="init" value="true">
        <fieldset>
            <div>
                <div class="mb-4" v-if="isCreate">
                    <div class="w-3/4 mx-auto">
                        <div class="grid grid-cols-4 gap-2 text-center">
                            <div @click="selectUI('Schedule')">
                                <div class="rounded-md hover:cursor-pointer hover:ring-1 hover:ring-gray-500 ring-inset hover:shadow-md"
                                    :class="{ 'text-gray-500 shadow-md bg-accent2-default hover:bg-accent2-hover': type == 'Schedule', 'hover:bg-gray-100 bg-white': type !== 'Schedule' }">
                                    <img src="@/assets/schedule.svg" height="200" width="150"
                                        :class="{ 'invert': type == 'Schedule' }">
                                </div>
                                <h4 class="mt-2"> {{ $t('general.paneTypes.schedule') }}</h4>
                            </div>
                            <div @click="selectUI('Freeform')">
                                <div class="rounded-md hover:cursor-pointer hover:ring-1 hover:ring-gray-500 ring-inset hover:shadow-md"
                                    :class="{ 'text-gray-500 shadow-md bg-accent2-default hover:bg-accent2-hover': type == 'Freeform', 'hover:bg-gray-100 bg-white': type !== 'Freeform' }">
                                    <img src="@/assets/freeform.svg" height="200" width="150"
                                        :class="{ 'invert': type == 'Freeform' }">
                                </div>
                                <h4 class="mt-2">{{ $t('general.paneTypes.freeform') }}</h4>
                            </div>
                            <div @click="selectUI('Stream')">
                                <div class="rounded-md hover:cursor-pointer hover:ring-1 hover:ring-gray-500 ring-inset hover:shadow-md"
                                    :class="{ 'text-gray-500 shadow-md bg-accent2-default hover:bg-accent2-hover': type == 'Stream', 'hover:bg-gray-100 bg-white': type !== 'Stream' }">
                                    <img src="@/assets/stream.svg" height="200" width="150"
                                        :class="{ 'invert': type == 'Stream' }">
                                </div>
                                <h4 class="mt-2"> {{ $t('general.paneTypes.stream') }}</h4>
                            </div>
                            <div @click="selectUI('Timeline')">
                                <div class="rounded-md hover:cursor-pointer hover:ring-1 hover:ring-gray-500 ring-inset hover:shadow-md"
                                    :class="{ 'text-gray-500 shadow-md bg-accent2-default hover:bg-accent2-hover': type == 'Timeline', 'hover:bg-gray-100 bg-white': type !== 'Timeline' }">
                                    <img src="@/assets/timeline.svg" height="200" width="150"
                                        :class="{ 'invert': type == 'Timeline' }">
                                </div>
                                <h4 class="mt-2"> {{ $t('general.paneTypes.timeline') }}</h4>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <Input v-model="headline" :placeholder="$t('adjustPanel.general.headline')"
                :label="$t('adjustPanel.general.headline')" type="text" icon="information-2" />
            <Input v-model="subheadline" :placeholder="$t('adjustPanel.general.subheadline')"
                :label="$t('adjustPanel.general.subheadline')" type="text" icon="draft" />
            <Input v-model="accesscode" :required="true" :placeholder="$t('general.variables.accesscode')"
                :label="$t('general.variables.accesscode')" :readonly="true" type="text" icon="home-2" />
            <MailChooser :key="mail" :saved-mail="mail" :read-only="true" :label="true" v-if="mail" />
            <MailChooser @domain="setDomain" @mail="setUsername" :label="true" v-else />
            <p class="text-orange-400 flex flex-row-reverse gap-1">
                <Tooltip :tooltip="$t('create.modHint')">{{ $t('create.modHintLabel') }}<i
                        class="ri-information-line ri-1x"></i></Tooltip>
            </p>
            <PasswordField v-model="aPassword" v-model:valid="aPasswordValid" :strong="true"
                :error-text="$t('adminMenu.passwordReset.error.password.strong')"
                :label="$t('general.variables.password.sg') + ' (' + $t('indexPage.buttonTexts.login.tabs.mod') + ')'"
                :mandatory="'false'" />
            <PasswordField v-model="uPassword" v-model:valid="uPasswordValid" :strong="false"
                :error-text="$t('adminMenu.passwordReset.error.password.user')"
                :label="$t('general.variables.password.sg') + ' (' + $t('indexPage.buttonTexts.login.tabs.user') + ')'"
                :mandatory="'true'" />
        </fieldset>
        <div class="relative bottom-0 w-full mt-2">
            <Button :variant="checkMail && uPassword.length >= 6 && uPasswordValid ? 'confirm' : 'disabled'"
                @click="setActivePage">
                <span>{{ $t('general.buttons.next') }}</span>
                <i class="ri-arrow-right-s-line"></i>
            </Button>
        </div>
    </div>
</template>